import type * as ts from 'typescript/lib/tsserverlibrary';
import { ICustomizedLanguageServie } from './decorator';
import { LanguageServiceLogger } from './logger';
import { DependExpression, FunctionExpressionLike, HooksReferenceNameType, Info, RefactorContext, UseCallbackInfo, UseMemoInfo } from './types';
export declare class CustomizedLanguageService implements ICustomizedLanguageServie {
    private readonly info;
    private readonly typescript;
    private readonly logger;
    constructor(info: ts.server.PluginCreateInfo, typescript: typeof ts, logger: LanguageServiceLogger);
    getApplicableRefactors(fileName: string, positionOrRange: number | ts.TextRange, preferences: ts.UserPreferences | undefined, triggerReason?: ts.RefactorTriggerReason): ts.ApplicableRefactorInfo[];
    getEditsForRefactor(fileName: string, formatOptions: ts.FormatCodeSettings, positionOrRange: number | ts.TextRange, refactorName: string, actionName: string, preferences: ts.UserPreferences | undefined): ts.RefactorEditInfo | undefined;
    getInfo(startPosition: number, endPosition: number, file: ts.SourceFile, program: ts.Program, full: boolean): Info | undefined;
    getInfoFromUniversalExpression(expression: ts.Expression, file: ts.SourceFile, checker: ts.TypeChecker, full: boolean): Info;
    getInfoFromFunctionExpressionLike(func: FunctionExpressionLike, file: ts.SourceFile, checker: ts.TypeChecker, full: boolean): Info;
    getEditsForConvertUseCallback(info: UseCallbackInfo, file: ts.SourceFile, textChangesContext: ts.textChanges.TextChangesContext): ts.RefactorEditInfo;
    getEditsForConvertUseMemo(info: UseMemoInfo, file: ts.SourceFile, textChangesContext: ts.textChanges.TextChangesContext): ts.RefactorEditInfo;
    wrapIntoUseCallback(func: FunctionExpressionLike, file: ts.SourceFile, deps: DependExpression[], hooksReference: HooksReferenceNameType | undefined, changeTracker: ts.textChanges.ChangeTracker): void;
    wrapIntoUseMemo(expression: ts.Expression, file: ts.SourceFile, deps: DependExpression[], hooksReference: HooksReferenceNameType | undefined, changeTracker: ts.textChanges.ChangeTracker): void;
    getRefactorContext(fileName: string): RefactorContext | undefined;
    getOutsideReferences(scope: ts.Node, additionalScope: readonly ts.Node[], file: ts.SourceFile, checker: ts.TypeChecker, preferFullAccess?: boolean): DependExpression[];
    isValidJsxFlag(): boolean;
    isNewJsxTransformer(): boolean;
}
